config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  PERMITTED_AREAS = /(state|city|census_sector|regional_health_coordination|technical_health_supervision|subprefecture|administrative_sector|ubs|family_health_strategy)/.freeze

  scope "(:locale)", locale: /#{I18n.available_locales.join("|")}/ do
    devise_for :users
    root 'homepage#index'

    resources :procedures, only: %i[index show] do
      post 'search/', to: 'procedures#search', on: :collection
      get 'search/', to: 'procedures#index', on: :collection
      get 'export/', to: 'procedures#export', on: :collection
      post 'print/', to: 'procedures#print', on: :collection
      get 'map_popup_on/:area/for/:id', to: 'procedures#map_popup_on_area', on: :collection, as: :map_popup_on_area, area: PERMITTED_AREAS
    end

    resources :health_facilities, only: [:show]

    resources :general_data, only: [:index] do
      post 'print/', to: 'general_data#print', on: :collection
    end

    resources :demographic_divisions do
      get 'geojson/:area', to: 'demographic_divisions#geojson', on: :collection, area: PERMITTED_AREAS
    end

    get 'about', to: 'static_pages#about'
    get 'guide', to: 'static_pages#guide'
  end
end

app/controllers/procedures_controller.rb
# frozen_string_literal: true

class ProceduresController < ApplicationController
  include RansackMemory::Concern
  include ProceduresSearchConcern

  before_action :save_and_load_filters, only: %i[search export print]
  before_action :set_search_results, only: %i[index search export print]

  def index
    @sectors_counts = {}
  end

  def search
    sectors_procedures_counter = DemographicDivisionsProceduresCounterService.new(@procedures_ids,
                                                                                  @heatmap_weight_model)
    sectors_procedures_counter.build_filters(csw_heat_map_params.to_h)
    @divisions_rates = sectors_procedures_counter.demographic_divisions_rates
  end

  def show
    @patient_datum = PatientDatum
                     .includes(
                       :administrative_sector, :subprefecture, :technical_health_supervision,
                       :regional_health_coordination, :census_sector
                     )
                     .find_by!(procedure_id: params[:id])

    @hospitalization_datum = HospitalizationDatum
                             .includes(:icd_category)
                             .find_by!(procedure_id: params[:id])

    render layout: false
  end

  def export
    @patients_data = PatientDatum.includes(
      { hospitalization_datum: %i[health_facility icd_subcategory secondary_icd1 secondary_icd2] },
      :administrative_sector,
      :subprefecture,
      :technical_health_supervision,
      :regional_health_coordination
    ).where(procedure_id: @procedures_ids)
  end

  def print
    @base64_map = print_params[:map_image]
    @heatmap_type, @heatmap_max = print_params[:heatmap_max]&.split(':')
    @heatmap_gradient = print_params[:heatmap_gradient]

    render pdf: 'procedures', orientation: 'Landscape', page_size: 'A4', layout: 'wicked_pdf'
  end

  def map_popup_on_area
    @content = ProceduresMapAreaContentPopupService.new(params[:area], params[:id]).build_popup_content

    render layout: false
  end

  private

  def csw_heat_map_params
    params.fetch(:csw_heat_map).permit(DemographicDivisionsProceduresCounterService::ALL_FILTERS)
  end

  def print_params
    params.permit(:map_image, :heatmap_max, :heatmap_gradient)
  end
end

app/helpers/procedures_helper.rb
# frozen_string_literal: true

module ProceduresHelper
  def model_icd_options(model_class)
    model_class.distinct
               .where.not(code: nil)
               .order(:code)
               .pluck(:code, :id, :description)
               .map do |option|
                 formated_option = option.clone
                 formated_option[0] = "#{option[0]} - #{option[2].titleize}"
                 formated_option[0..1]
               end
  end

  def icd_category_options
    model_icd_options(IcdCategory)
  end

  def icd_subcategory_options
    model_icd_options(IcdSubcategory)
  end

  def model_number_attribute_options(model_class, attribute)
    model_class.distinct
               .where
               .not(attribute => nil)
               .order(attribute)
               .pluck(attribute)
  end

  def hospitalization_type_options
    translate_options(
      model_number_attribute_options(HospitalizationDatum, :hospitalization_type),
      'hospitalization_type'
    )
  end

  def complexity_options
    translate_options(model_number_attribute_options(HospitalizationDatum, :complexity), 'complexity')
  end

  def specialty_options
    translate_options(model_number_attribute_options(HospitalizationDatum, :specialty), 'specialty')
  end

  def competence_options
    model_number_attribute_options(HospitalizationDatum, :competence)
  end

  def hospitalization_group_options
    model_number_attribute_options(HospitalizationDatum, :hospitalization_group)
  end

  def financing_options
    translate_options(model_number_attribute_options(HospitalizationDatum, :financing), 'financing')
  end

  def max_hospitalization_days
    HospitalizationDatum.maximum(:hospitalization_days)
  end

  def max_hospitalization_rates
    HospitalizationDatum.maximum(:hospitalization_rates)
  end

  def max_uti_rates
    HospitalizationDatum.maximum(:uti_rates)
  end

  def max_ui_rates
    HospitalizationDatum.maximum(:ui_rates)
  end

  def max_service_value
    HospitalizationDatum.maximum(:service_value)
  end

  def max_distance
    HospitalizationDatum.maximum(:distance)
  end

  def translate_options(options, scope)
    options.map { |option| [I18n.t(option, scope: "hospitalization_datum.#{scope}"), option] }
  end

  def legend_div_with_title(name, title)
    render partial: 'procedures/filters/filter_legend', locals: { name: name, title: title }
  end

  def division_present_in_class(klass, division)
    klass.column_names.include?("#{division}_id") and klass.where.not("#{division}_id".to_sym => nil).any?
  end

  def map_center
    HealthFacility.pick(Arel.sql('PERCENTILE_CONT(0.5) WITHIN GROUP(ORDER BY latitude)'),
                        Arel.sql('PERCENTILE_CONT(0.5) WITHIN GROUP(ORDER BY longitude)'))
  end
end

app/views/procedures/_pdf_generator.html.erb
<%= javascript_pack_tag 'procedures_map/ImageGenerator' %>

<%= form_with url: print_procedures_path, id: 'image_form' do %>
  <%= hidden_field_tag :map_image  %>
  <%= hidden_field_tag :heatmap_max  %>
  <%= hidden_field_tag :heatmap_gradient  %>
<% end %>

<%= javascript_tag do %>
  var formInputs = [
    {id: 'map_image', val: (canvas) => canvas.toDataURL('image/png')},
    {id: 'heatmap_max', val: () => proceduresMap.currentHeatmapLayer()},
    {id: 'heatmap_gradient', val: () => proceduresMap.heatmapGradientCSS()}
  ]

  imageGenerator = new ImageGenerator(html2canvas, $, 'image_form', formInputs);
<% end %>

<%= link_to t('.pdf'), 'javascript:;', class: 'm-2 btn btn-secondary overlay-button', onclick: "imageGenerator.generate('map')" %>

app/views/procedures/_procedure.csv.erb
<%= [
  patient_data.procedure_id,
  patient_data.latitude,
  patient_data.longitude,
  patient_data.gender,
  patient_data.age_year,
  patient_data.race,
  patient_data.educational_level,
  patient_data.hospitalization_datum.health_facility.cnes,
  patient_data.hospitalization_datum.gestor_id,
  patient_data.hospitalization_datum.hospitalization_type,
  patient_data.hospitalization_datum.competence,
  patient_data.hospitalization_datum.issue_date,
  patient_data.hospitalization_datum.admission_date,
  patient_data.hospitalization_datum.leave_date,
  patient_data.hospitalization_datum.complexity,
  patient_data.hospitalization_datum.hospitalization_group,
  patient_data.hospitalization_datum.icd_subcategory.code,
  patient_data.hospitalization_datum.secondary_icd1 ? patient_data.hospitalization_datum.secondary_icd1.code : nil,
  patient_data.hospitalization_datum.secondary_icd2 ? patient_data.hospitalization_datum.secondary_icd2.code : nil,
  patient_data.hospitalization_datum.hospitalization_rates,
  patient_data.hospitalization_datum.uti_rates,
  patient_data.hospitalization_datum.uti_rates,
  patient_data.hospitalization_datum.hospitalization_days,
  patient_data.hospitalization_datum.financing,
  patient_data.hospitalization_datum.service_value,
  patient_data.administrative_sector.name,
  patient_data.subprefecture.name,
  patient_data.technical_health_supervision.name,
  patient_data.regional_health_coordination.name,
  patient_data.hospitalization_datum.distance
].join(';') %>

app/views/procedures/export.csv.erb
COD;LAT_SC;LONG_SC;P_SEXO;P_IDADE;P_RACA;LV_INSTRU;CNES;GESTOR_ID;CAR_INTEN;CMPT;DT_EMISSAO;DT_INTERNA;DT_SAIDA;COMPLEXIDA;PROC_RE;DIAG_PR;DIAG_SE1;DIAG_SE2;DIARIAS;DIARIAS_UT;DIARIAS_UI;DIAS_PERM;FINANC;VAL_TOT;DA;SUB;STS;CRS;DISTANCIA_KM
<% @patients_data.find_in_batches do |patients_data_batch| %>
  <%= render partial: 'procedures/procedure', formats: [:csv], collection: patients_data_batch, as: :patient_data, cached: true %>
<% end %>

app/views/procedures/index.html.erb
<div class="container-fluid px-0 h-100">
  <div class="row no-gutters h-100">
    <div id="map" class="col"></div>

    <div class="filters col-md-auto py-2 px-2" style="width: 375px; min-height: 100%">
      <h5><%= t('.filters') %></h5>

      <%= javascript_pack_tag 'procedures_map/SelectedFiltersLegend' %>

      <div id="filters-accordion">
        <%= search_form_for @search, url: search_procedures_path, html: { method: :post }, remote: true, id: 'search-form' do |f| %>
          <%= render partial: 'procedures/filters/health_facilities', locals: { form: f } %>

          <%= render partial: 'procedures/filters/procedures', locals: { form: f } %>

          <%= render partial: 'procedures/filters/patients', locals: { form: f } %>

          <%= render partial: 'procedures/filters/csw_heat_map' %>

          <%= submit_tag(t('.search'), class: 'm-2 btn btn-primary', onclick: "loadingOverlay.showOverlay()") %>

          <btn id="clear-filters-button" class="m-2 btn btn-secondary"><%= t('.clear_filters') %></btn>
        <% end %>

      </div>

      <%= javascript_tag do %>
        $('#filters-accordion').find('select').change();
      <% end %>

      <h5 class="pt-4"><%= t '.map_options' %></h5>

      <%= render partial: 'procedures/map/options' %>

      <h5 class="pt-4"><%= t '.export' %></h5>

      <div>
        <div class="float-left">
          <%= link_to t('.download_csv'), export_procedures_path(format: :csv), class: 'm-2 btn btn-secondary' %>
        </div>

        <div class="float-left">
          <%= render partial: 'pdf_generator' %>
        </div>
      </div>
    </div>
  </div>
</div>

<div class="modal justify-content-center" data-backdrop="static" data-keyboard="false" id="loading-overlay" role="overlay">
  <div class="modal-dialog d-flex h-100 mt-0 mx-auto">
    <div class="spinner-border text-light justify-content-center align-self-center mx-auto" role="status">
      <span class="sr-only">Loading...</span>
    </div>
  </div>
</div>

<%= render partial: 'procedures/map/load', formats: [:js], locals: {
  health_facilities: prepare_health_facilities_data(@health_facilities, false).to_json
} %>

app/views/procedures/map_popup_on_area.html.erb
<% @content.each do |attribute, value| %>
  <b><%= t(".#{attribute}") %></b>: <%= value %> <br>
<% end %>

app/views/procedures/print.html.erb
<div class="container">
  <div class="map">
    <img src="<%= @base64_map %>">
  </div>

  <div class="information">
    <h1><%= t 'procedures.pdf_generator.title' %></h1>

    <h2><%= t 'procedures.pdf_generator.filters' %></h2>

    <%= render partial: 'shared/services/active_filters', locals: {
      active_filters: @active_filters
    } %>

    <h2 class="pt-4"><%= t 'procedures.pdf_generator.legend' %></h2>

    <p>
      <%= wicked_pdf_image_tag 'ESTADUAL_hf_icon.png' %> <%= t 'procedures.pdf_generator.state' %> <%= wicked_pdf_image_tag 'MUNICIPAL_hf_icon.png' %> <%= t 'procedures.pdf_generator.city' %> <%= wicked_pdf_image_tag 'OUTROS_hf_icon.png' %> <%= t 'procedures.pdf_generator.others' %>
    </p>

    <% if @heatmap_type.present? %>
      <h4 class="pt-4"><%= t "procedures.pdf_generator.#{@heatmap_type}_heatmap_legend" %></h4>
      <div id="heatmap-legend" class="row" style="display: flex;width: 270px">
        <div style="margin-right: 10px;padding-top: 5px">0</div>
        <div class="col-1" style="background-image: <%= @heatmap_gradient %>;height: 30px;flex: 2;"></div>
        <div style="margin-left: 10px;padding-top: 5px"><%= @heatmap_max %></div>
      </div>
    <% end %>

    <h2><%= t 'procedures.pdf_generator.source_title' %></h2>

    <p>
      <%= t 'procedures.pdf_generator.source_text' %><br>
      <%= t 'procedures.pdf_generator.source_url' %>
    </p>
  </div>
</div>

app/views/procedures/search.json.erb
<%== {
  patients_data: @patients_latlong_array,
  health_facilities: prepare_health_facilities_data(@health_facilities, true),
  divisions_rates: @divisions_rates
}.to_json %>

app/views/procedures/show.html.erb
<b><%= t('.gender') %></b>: <%= human_attribute_value(@patient_datum, 'gender') %> <br>
<b><%= t('.race') %></b>: <%= human_attribute_value(@patient_datum, 'race') %> <br>
<b><%= t('.age_year') %></b>: <%= @patient_datum.age_year %> <br>
<b><%= t('.educational_level') %></b>: <%= human_attribute_value(@patient_datum, 'educational_level') %> <br>
<% %w[state city census_sector administrative_sector subprefecture
      technical_health_supervision regional_health_coordination].each do |division| %>
 <% if division_present_in_class(PatientDatum, division) %>
    <b><%= t(".#{division}") %></b>: <%= @patient_datum.send(division).name %> <br>
  <% end %>
<% end %>
<b><%= t('.icd_category') %></b>: <%= @hospitalization_datum.icd_category&.description %> <br>
<b><%= t('.admission_date') %></b>: <%= @hospitalization_datum.admission_date %> <br>
<b><%= t('.distance') %></b>: <%= @hospitalization_datum.distance %> km <br>
<b><%= t('.health_facility') %></b>: <%= @hospitalization_datum.health_facility.name %>